<i18n>
{
  "fr": {
    "field-3": "Mode",
    "field-4": "Covoiturage",
    "field-5": "Quantité",
    "field-6": "Statut de l'agent",
    "field-7": "Motif du déplacement",
    "add-step": "Ajouter une étape",
    "delete": "Supprimer une étape",
    "round-trip": "Trajet aller / retour",
    "carbon-footprint": "Empreinte carbone",
    "contrails": "avec traînées",
    "section": "Liaison",
    "understand-calculation": "Comprendre le calcul",
    "total-distance": "Distance totale",
    "understanding-txt": "<ul style='list-style-type:square;margin-left:25px'><li>Calcul de la <strong>distance à vol d’oiseau</strong> entre la ville de départ et la ville de destination à partir de <strong>geonames</strong> ;</li><li>A ces distances à vol d’oiseau, nous avons appliqué les <strong>coefficients multiplicateurs</strong> suivants : 1,3 pour les déplacements en voiture, 1,2 pour le train et pour le RER, 1,7 pour le métro, 1,5 pour le bus et le tramway ; </li><li>Pour les déplacements en taxi, la distance routière du retour est systématiquement prise en compte et correspond à la distance aller ;</li><li>Pour les déplacements en <strong>avion</strong>, <strong>95km</strong> sont <strong> ajoutés</strong> à la distance à vol d’oiseau.</li></ul>",
    "emissions-txt": "<strong>Emissions</strong> d'une étape = <strong>distance</strong> parcourue * <strong>facteur d’émission</strong> du mode de déplacement (par km parcouru ou par passager-km)",
    "emissions-contrails" : "Les résultats fournis par <em>GES 1point5</em> se basent sur la <strong>réglementation française</strong> qui préconise, pour l'aviation, de prendre en compte les émissions de GES liées à la combustion et à l'amont du combustible, sans inclure les émissions liées aux traînées de condensation. Le <strong>forçage radiatif de ces traînées est important</strong> même si son <strong>ampleur précise est incertaine</strong>. Pour cela, <em>GES 1point5</em> affiche aussi, à titre indicatif, l'empreinte carbone totale en incluant les traînées dans les émissions des déplacements en avion."
  },
  "en": {
    "field-3": "Travel mode",
    "field-4": "Carpooling",
    "field-5": "No of trips",
    "field-6": "Member position",
    "field-7": "Travel purpose",
    "add-step": "Add a section",
    "delete": "Delete a section",
    "round-trip": "Round trip",
    "carbon-footprint": "Carbon footprint",
    "contrails": "with contrails",
    "section": "Section",
    "understand-calculation": "Understand calculation",
    "total-distance": "Total distance",
    "understanding-txt": "<ul style='list-style-type:square;margin-left:25px'><li>Calculation of the <strong>distance as the crow flies</strong> between the city of departure and the city of destination from <strong>geonames</strong> ;</li><li>To these distances as the crow flies, we apply the following <strong>multiplying factors</strong>: 1.3 for car travel, 1.2 for train and suburban train, 1.7 for metro, 1.5 for bus and tram ; </li><li>For taxi journeys, the return road distance is systematically taken into account and corresponds to the outward distance ;</li><li>For air travel, <strong>95km</strong> is added to the distance as the crow flies.</li></ul>",
    "emissions-txt": "<strong>Emissions</strong> of a section = <strong>distance</strong> travelled * <strong>emission factor</strong> of the travel mode (per km travelled or per passenger-km)",
    "emissions-contrails" : "The results provided by <em>GES 1point5</em> are based on the <strong>French regulation</strong> that advocates, for aviation emissions, to take into account the emissions linked to fuel combustion, and to exclude emissions from condensation trails. The <strong>radiative forcing of these contrails is significant</strong> even if its <strong>magnitude is still uncertain</strong>. Therefore, <em>GES 1point5</em> also displays for information, the total carbon footprint including contrails in the emissions from air travel."
  }
}
</i18n>

<template>
  <form @submit.prevent="validateBeforeSubmit">
    <div class="columns">
      <div class="column">
        <b-notification :closable="false">
          <div class="level-item has-text-centered">
            <div>
              <p class="heading has-text-distance">
                {{ $t('total-distance') }}
                <b-tooltip
                  size="is-large"
                  multilined
                  position="is-right"
                  dashed type="is-info"
                >
                  ({{ $t('understand-calculation') }})
                  <template v-slot:content>
                    <span v-html="$t('understanding-txt')" />
                  </template>
                </b-tooltip>
              </p>
              <div class="title is-size-4 has-text-distance">
                <p v-if="displayValues">
                  {{ distance | splitNumber }}
                  <span class="is-size-6">km</span>
                </p>
                <p v-else>
                  ...
                  <span class="is-size-6">km</span>
                </p>
              </div>
            </div>
          </div>
        </b-notification>
      </div>
      <div class="column">
        <b-notification :closable="false">
          <div class="level-item has-text-centered">
            <div>
              <p class="heading has-text-carbone">
                {{ $t('carbon-footprint') }}
                <b-tooltip
                  size="is-large"
                  multilined
                  position="is-right"
                  dashed type="is-info"
                >
                  ({{ $t('understand-calculation') }})
                  <template v-slot:content>
                    <span v-html="$t('emissions-txt')" />
                  </template>
                </b-tooltip>
              </p>
              <div class="title is-size-4 has-text-carbone">
                <p v-if="displayValues">
                  {{ Math.round(intensity.intensity) | splitNumber }} &plusmn;
                  {{ Math.round(intensity.uncertainty) | splitNumber }}
                  <span class="is-size-6">{{ $t('kg.co2e') }}</span>
                </p>
                <p v-else>
                  ...
                  <span class="is-size-6">{{ $t('kg.co2e') }}</span>
                </p>
              </div>
            </div>
          </div>
        </b-notification>
      </div>
      <div class="column">
        <b-notification :closable="false">
          <div class="level-item has-text-centered">
            <div>
              <p class="heading has-text-carbone2">
                {{ $t('carbon-footprint') }}
                <b-tooltip
                  size="is-large"
                  multilined
                  position="is-left"
                  dashed type="is-info"
                >
                  ({{ $t('contrails') }})
                  <template v-slot:content>
                    <span v-html="$t('emissions-contrails')" />
                  </template>
                </b-tooltip>
              </p>
              <div class="title is-size-4 has-text-carbone2">
                <p v-if="displayValues && intensity.intensitywc !== intensity.intensity">
                  {{ Math.round(intensity.intensitywc) | splitNumber }} &plusmn;
                  {{ Math.round(intensity.uncertaintywc) | splitNumber }}
                  <span class="is-size-6">{{ $t('kg.co2e') }}</span>
                </p>
                <p v-else>
                  ...
                  <span class="is-size-6">{{ $t('kg.co2e') }}</span>
                </p>
              </div>
            </div>
          </div>
        </b-notification>
      </div>
    </div>
    <b-notification v-if="!isSimulation" :closable="false">
      <div class="columns">
        <div class="column">
          <b-field
            :label="$t('id') + '*'"
            :type="{'is-danger': errors.has('names')}"
            :message="errors.first('names')"
          >
            <b-taginput
              :disabled="!modeCreation"
              name="names"
              v-validate="'required'"
              icon="tags"
              v-model="ctravel.names"
            ></b-taginput>
          </b-field>
        </div>
        <div class="column">
          <b-field
            :label="$t('field-5') + '*'"
            :type="{'is-danger': errors.has('amount')}"
            :message="errors.first('amount')"
          >
            <b-input
              name="amount"
              @input="updateDistance"
              v-validate="'required|numeric|min_value:1'"
              v-model="ctravel.amount"
              type="number"
            ></b-input>
          </b-field>
        </div>
        <div class="column">
          <b-field
            :label="$t('field-7')"
          >
            <b-select
              expanded
              :placeholder="$t('field-7')"
              v-model="ctravel.purpose"
            >
              <option
                :value="purpose"
                v-for="(purpose,index) in purposes"
                :key="index"
              >
                {{ $t(purpose) }}
              </option>
            </b-select>
          </b-field>
        </div>
        <div class="column">
          <b-field
            :label="$t('field-6')"
          >
            <b-select
              expanded
              :placeholder="$t('field-6')"
              v-model="ctravel.status"
            >
              <option
                :value="status"
                v-for="(status,index) in allStatus"
                :key="index"
              >
                {{ $t(status) }}
              </option>
            </b-select>
          </b-field>
        </div>
      </div>
    </b-notification>
    <div class="columns">
      <div class="column">
        <b-notification :closable="false">
          <b-switch
            v-model="isRoundTrip"
            @input="updateRoundTrip"
          >
            {{ $t('round-trip') }}
          </b-switch>
        </b-notification>
        <b-notification :closable="false">
          <b-steps
            :has-navigation="false"
            v-model="activeSection"
          >
            <b-step-item
              v-for="(section,index) in ctravel.sections"
              :key="index"
              :step="stepDisplay(index)"
              :type="((!modeCreation && !isSimulation && !section.isValid()) ? 'is-danger' : 'is-primary')"
              class="mt-1 mb-1"
              :clickable="true"
            >
              <h1 class="title has-text-centered mb-2">
                {{ $t('section') }} {{ stepDisplay(index) }}
              </h1>
              <br />
              <travel-section-form
                v-model="ctravel.sections[index]"
                @input="updateDistance"
                @update-departure="updateDeparture(index, ...arguments)"
                @update-destination="updateDestination(index, ...arguments)"
              />
            </b-step-item>
          </b-steps>
        </b-notification>
        <div class="columns">
          <div class="column">
            <b-button
              expanded
              icon-left="minus"
              :disabled="activeSection !== ctravel.sections.length - 1 || activeSection === 0"
              @click="deleteSection"
            >{{ $t('delete') }}</b-button>
          </div>
          <div class="column">
            <b-button
              expanded
              :disabled="activeSection !== ctravel.sections.length - 1"
              type="is-primary"
              icon-left="plus"
              @click="addSection"
            >
              {{ $t('add-step') }}
            </b-button>
          </div>
        </div>
      </div>
      <div class="column">
        <l-map
          ref="map"
          :bounds="bounds"
          style="z-index: 0;"
          :style="[!ctravel.latLngIsValid() ? { border:'1px solid #ff3880' } : { border:'1px solid #4280b0' } ]"
        >
          <l-tilelayer url="https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png"></l-tilelayer>
          <l-marker
            :lat-lng="firstMarker"
            :icon="createIcon(1)"
          />
          <template v-for="(section,index) in ctravel.sections">
            <l-marker
              v-if="section.destinationCityLat !== 0 && section.destinationCityLng !== 0 && section.destinationCityLat !== null && section.destinationCityLng !== null"
              :key="index"
              :lat-lng="[section.destinationCityLat, section.destinationCityLng]"
              :icon="createIcon(index + 2)"
            />
          </template>
        </l-map>
      </div>
    </div>
    <hr v-if="!isSimulation">
    <nav
      v-if="!isSimulation"
      class="level"
    >
      <div class="level-left"></div>
      <div class="buttons level-right">
        <b-button
          class="button"
          @click="$emit('close')"
          icon-left="close"
        >
          {{ $t('cancel') }}
        </b-button>
        <button
          type="submit"
          class="button is-primary"
        >
          <span class="icon is-small"><i class="sui sui-plus"></i></span>
          <span v-if='modeCreation'> {{ $t('add') }} </span>
          <span v-else> {{ $t('update') }} </span>
        </button>
      </div>
    </nav>
  </form>
</template>

<script>
import L, { latLng, latLngBounds } from 'leaflet'
import iconBlue from '@/assets/images/leaflet-markers/marker-icon-blue-full.png'
import iconGrey from '@/assets/images/leaflet-markers/marker-icon-grey-full.png'
import shadow from '@/assets/images/leaflet-markers/marker-shadow.png'
import TravelSection from '@/models/carbon/TravelSection.js'
import Travel from '@/models/carbon/Travel.js'
import '@/plugins/leaflet.js'
import 'leaflet.geodesic'

L.NumberedBlueIcon = L.Icon.extend({
  options: {
    iconUrl: iconBlue,
    number: '',
    shadowUrl: shadow,
    iconSize: new L.Point(25, 41),
    iconAnchor: new L.Point(13, 41),
    popupAnchor: new L.Point(0, -33),
    className: 'leaflet-div-icon'
  },

  createIcon () {
    const div = document.createElement('div')
    const img = this._createImg(this.options.iconUrl)
    const numdiv = document.createElement('div')
    numdiv.setAttribute('class', 'marker-number')
    numdiv.innerHTML = this.options.number || ''
    div.appendChild(img)
    div.appendChild(numdiv)
    div.classList.add('leaflet-div-icon')
    this._setIconStyles(div, 'icon')
    return div
  },

  createShadow () {
    const div = document.createElement('div')
    const img = this._createImg(this.options.shadowUrl)
    div.appendChild(img)
    this._setIconStyles(div, 'icon')
    return div
  }
})

L.NumberedGreyIcon = L.Icon.extend({
  options: {
    iconUrl: iconGrey,
    number: '',
    shadowUrl: shadow,
    iconSize: new L.Point(25, 41),
    iconAnchor: new L.Point(13, 41),
    popupAnchor: new L.Point(0, -33),
    className: 'leaflet-div-icon'
  },

  createIcon () {
    const div = document.createElement('div')
    const img = this._createImg(this.options.iconUrl)
    const numdiv = document.createElement('div')
    numdiv.setAttribute('class', 'marker-number')
    numdiv.innerHTML = this.options.number || ''
    div.appendChild(img)
    div.appendChild(numdiv)
    div.classList.add('leaflet-div-icon')
    this._setIconStyles(div, 'icon')
    return div
  },

  createShadow () {
    const div = document.createElement('div')
    const img = this._createImg(this.options.shadowUrl)
    div.appendChild(img)
    this._setIconStyles(div, 'icon')
    return div
  }
})

export default {
  name: 'TravelForm',
  props: {
    travel: {
      type: Object,
      default: function () {
        return {}
      }
    },
    modeCreation: {
      type: Boolean,
      default: false
    },
    isSimulation: {
      type: Boolean,
      default: false
    }
  },
  components: {
    'l-map': () => import('vue2-leaflet').then(({ LMap }) => LMap),
    'l-tilelayer': () => import('vue2-leaflet').then(({ LTileLayer }) => LTileLayer),
    'l-marker': () => import('vue2-leaflet').then(({ LMarker }) => LMarker),
    'travel-section-form': () => import('@/components/carbon/forms/TravelSectionForm.vue')
  },
  $_veeValidate: {
    validator: 'new'
  },
  data () {
    return {
      ctravel: Travel.createFromObj(this.travel),
      transportations: Travel.transportations,
      purposes: Travel.purposes,
      allStatus: Travel.status,
      intensity: null,
      distance: null,
      isRoundTrip: false,
      geodesicLines: null,
      currentGeodesicLines: null,
      activeSection: 0
    }
  },
  computed: {
    displayValues: function () {
      return this.ctravel.isComplete() && this.distance !== null && this.distance !== 0
    },
    GHGIYear: function () {
      return new Date().getFullYear()
    },
    firstMarker: function () {
      if (this.ctravel.sections.length > 0) {
        return [
          this.ctravel.sections[0].departureCityLat,
          this.ctravel.sections[0].departureCityLng
        ]
      } else {
        return [0.0, 0.0]
      }
    },
    bounds: function () {
      if (this.ctravel.sections.length > 0 && this.ctravel.latLngIsValid()) {
        if (this.ctravel.sections[0].departureCity !== null || this.ctravel.sections[0].destinationCity !== null) {
          let lons = this.ctravel.sections.map((section) => parseFloat(section.departureCityLng))
          lons.push(...this.ctravel.sections.map((section) => parseFloat(section.destinationCityLng)))
          if (lons.indexOf(0) !== -1) {
            lons.splice(lons.indexOf(0), 1)
          }
          let lats = this.ctravel.sections.map((section) => parseFloat(section.departureCityLat))
          lats.push(...this.ctravel.sections.map((section) => parseFloat(section.destinationCityLat)))
          if (lats.indexOf(0) !== -1) {
            lats.splice(lats.indexOf(0), 1)
          }
          return latLngBounds([
            latLng(Math.min(...lats) - 0.5, Math.min(...lons) - 0.5),
            latLng(Math.max(...lats) + 0.5, Math.max(...lons) + 0.5)
          ])
        } else {
          return latLngBounds([
            latLng(-20, -20),
            latLng(20, 20)
          ])
        }
      } else {
        return latLngBounds([
          latLng(-20, -20),
          latLng(20, 20)
        ])
      }
    }
  },
  methods: {
    modeIcon: function () {
      return Travel.getIcon(this.ctravel.transportation)
    },
    modePack: function () {
      return Travel.getIconPack(this.ctravel.transportation)
    },
    addSection () {
      this.$validator.validateAll().then((result) => {
        if (result) {
          let savedDestination = Object.assign({}, this.ctravel.sections[this.ctravel.sections.length - 1])
          let ctravelSection = new TravelSection()
          ctravelSection.departureCity = savedDestination.destinationCity
          ctravelSection.departureCountry = savedDestination.destinationCountry
          ctravelSection.departureCityLat = savedDestination.destinationCityLat
          ctravelSection.departureCityLng = savedDestination.destinationCityLng
          this.ctravel.addSection(ctravelSection)
          this.drawGeodesicLines()
          // dirty but not working directly
          let self = this
          setTimeout(
            function () {
              self.activeSection = self.ctravel.sections.length - 1
            },
            5
          )
        }
      })
    },
    stepDisplay (index) {
      let display = index + 1
      if (this.ctravel.sections[index].destinationCity !== null) {
        let index2 = index + 2
        display += '-' + index2
      }
      return display
    },
    updateDeparture (index, section, prevCityName) {
      if (index > 0 && this.ctravel.sections[index - 1].destinationCity === prevCityName) {
        this.ctravel.sections[index - 1].destinationCity = section.departureCity
        this.ctravel.sections[index - 1].destinationCountry = section.departureCountry
        this.ctravel.sections[index - 1].destinationCityLat = section.departureCityLat
        this.ctravel.sections[index - 1].destinationCityLng = section.departureCityLng
        this.updateDistance()
        this.drawGeodesicLines()
      }
    },
    updateDestination (index, section, prevCityName) {
      if ((index < this.ctravel.sections.length - 1) && this.ctravel.sections[index + 1].departureCity === prevCityName) {
        this.ctravel.sections[index + 1].departureCity = section.destinationCity
        this.ctravel.sections[index + 1].departureCountry = section.destinationCountry
        this.ctravel.sections[index + 1].departureCityLat = section.destinationCityLat
        this.ctravel.sections[index + 1].departureCityLng = section.destinationCityLng
        this.updateDistance()
        this.drawGeodesicLines()
      }
    },
    deleteSection () {
      this.ctravel.sections.splice(this.ctravel.sections.length - 1, 1)
      this.updateDistance()
      this.drawGeodesicLines()
      this.activeSection = this.ctravel.sections.length - 1
    },
    createIcon (number) {
      if (number === this.activeSection + 1) {
        return new L.NumberedBlueIcon({ number: number.toString() })
      } else if (number === this.activeSection + 2) {
        return new L.NumberedBlueIcon({ number: number.toString() })
      } else {
        return new L.NumberedGreyIcon({ number: number.toString() })
      }
    },
    drawGeodesicLines () {
      if (this.$refs.map !== undefined) {
        const map = this.$refs.map.mapObject
        let sectionsOK = this.ctravel.sections.filter(obj => {
          return obj.departureCity !== null && obj.destinationCity !== null
        })
        if (sectionsOK.length > 0) {
          let coordsOK = []
          let currentCoords = []
          let index = 0
          for (let section of sectionsOK) {
            if (index === this.activeSection) {
              currentCoords.push([
                new L.LatLng(section.departureCityLat, section.departureCityLng),
                new L.LatLng(section.destinationCityLat, section.destinationCityLng)
              ])
            } else {
              coordsOK.push([
                new L.LatLng(section.departureCityLat, section.departureCityLng),
                new L.LatLng(section.destinationCityLat, section.destinationCityLng)
              ])
            }
            index += 1
          }
          if (this.geodesicLines) {
            this.geodesicLines.setLatLngs(coordsOK)
          } else {
            this.geodesicLines = new L.Geodesic(coordsOK, { color: 'grey' }).addTo(map)
          }
          if (this.currentGeodesicLines) {
            this.currentGeodesicLines.setLatLngs(currentCoords)
          } else {
            this.currentGeodesicLines = new L.Geodesic(currentCoords).addTo(map)
          }
        }
      }
    },
    validateBeforeSubmit () {
      this.$validator.validateAll().then((result) => {
        if (result) {
          if (this.modeCreation) {
            this.$emit('add', this.ctravel)
          } else {
            this.$emit(
              'update',
              {
                'from': this.travel,
                'to': this.ctravel
              }
            )
          }
        }
      })
    },
    updateRoundTrip: function () {
      for (let section of this.ctravel.sections) {
        section.isRoundTrip = this.isRoundTrip
      }
      this.updateDistance()
    },
    updateDistance: function () {
      this.distance = Math.round(this.ctravel.getDistance())
      if (this.ctravel.isRoundTrip()) {
        this.distance *= 2
      }
      this.drawGeodesicLines()
      this.updateIntensity()
    },
    updateIntensity: function () {
      this.intensity = this.ctravel.getCarbonIntensity(this.GHGIYear)
    }
  },
  watch: {
    /* travel: {
      handler () {
        this.ctravel = Travel.createFromObj(this.travel)
      },
      deep: true
    }, */
    activeSection: function () {
      this.drawGeodesicLines()
    }
  },
  mounted () {
    let self = this
    setTimeout(
      function () {
        self.updateDistance()
        self.isRoundTrip = self.ctravel.isRoundTrip()
      },
      500
    )
    let index = 0
    for (let section of this.ctravel.sections) {
      if (!section.isValid()) {
        break
      }
      index += 1
    }
    this.activeSection = index
    if (!this.modeCreation && !this.isSimulation) {
      this.$validator.validateAll()
    }
  }
}
</script>

<style>
.has-text-distance {
  color: #935458 !important;
}
.has-text-carbone {
  color: #8e6a9e !important;
}
.has-text-carbone2 {
  color: #208dbc !important;
}
.leaflet-div-icon {
  background: transparent;
  border: none;
}

.leaflet-marker-icon .marker-number {
  position: relative;
  top: -45px;
  color: white;
  font-weight: bold;
  font-size: 1rem;
  text-align: center;
}
a.step-link.is-clickable {
  text-decoration: none !important;
}
.heading .tooltip-content {
  text-transform: none;
}
.heading .b-tooltip.is-multiline.is-large .tooltip-content {
    width: 500px;
}
.b-tooltip.is-multiline .tooltip-content {
    text-align: left !important;
}
</style>
